% Reads output u-s.txt
% Derived from summary_W12.f90 changes into MATLAB
% Wouter van der Wal, May 2, 2013

clear all
close all
clc

numt = 22;          % (from 26 ka BP to 1 ka after present)
nosites = 392;
num_reltime = 2;

time = [10; 
    15
    22.5000000000000
    33.7500000000000
    50.6250000000000
    75.9375000000000
    113.906250000000
    170.859375000000
    256.289062500000
    384.433593750000
    576.650390625000
    864.975585937500
    1297.46337890625
    1946.19506835938
    2919.29260253906
    4378.93890380859
    6568.40835571289
    9852.61253356934
    14778.9188003540
    22168.3782005310
    33252.5673007965];

% Make longitude and latitude vectors
ii = 0;
lons = zeros(91,181);
lats = zeros(91,181);
for i=90:-2:-90;
    ii = ii+1;
    jj = 0;
    for j=-180:2:180;
        jj = jj+1;
        lons(ii,jj) = j;
        lats(ii,jj) = i;
    end
end
lats = lats';
lons = lons';

% Read results from the fortran program fem3_W12.f90
a = load('./u-s.txt');
ii = 0;
radial = zeros(23,91,181);
for kt=0:1:numt;
    latii = 0;
    for lat =90:-2:-90;
        latii = latii+1;
        lonii = 0;
        for lon =-180:2:180;
            lonii = lonii +1;
            ii = ii+1;
            radial(kt+1,latii,lonii)  = a(ii,2);
        end
    end
end
a1 = radial(2,:,:);
a2 = reshape(a1,91,181);
figure(10); imagesc(a2); title('radial displacement'); colorbar
% Calculate minimum
figure(20); 
mindisp = zeros(21,1);
for ii = 3:23
    mindisp(ii-2) = min(min(radial(ii,:,:)));
end
plot(time,mindisp,'LineWidth',2)
xlabel('time [years]')
ylabel('minimum displacement [m]')
f2 = fit(time,mindisp,'smoothingspline');
% Derivative
timevec = [0:2:time(end)];
y = feval(f2,timevec);
yp = 1000*differentiate(f2,timevec);
figure(30); hold on
hd(jj) = plot(timevec,yp,'LineWidth',2,'Displayname','1D');
[i,minp] = min( abs(   abs(yp-yp(1))-abs( (1-exp(-num_reltime))*yp(1) ) ) );
figure(30); plot(timevec(minp),yp(minp),'x','MarkerEdgeColor','k','MarkerSize',10,'Displayname','1D')
text(timevec(minp),yp(minp)+10,num2str(timevec(minp)))
reltime4 = timevec(minp)/num_reltime;
disp(['relaxation time 3D = ',num2str(reltime4)])



ylabel('uplift rate [mm/year]','FontSize',14)
xlabel('time since loading [yr]','FontSize',14);
set(gca,'FontSize',14)
title('Weddell SLHE w10','FontSize',14);


% % % %% Read results from the fortran program fem3_W12.f90
% % % a = load('D:\Docs\MyPapers\Pippa_Antarctica3D\lay\wouterCaps\iterate-2_Amundsen\u-s.txt');
% % % ii = 0;
% % % radial = zeros(23,91,181);
% % % for kt=0:1:numt;
% % %     latii = 0;
% % %     for lat =90:-2:-90;
% % %         latii = latii+1;
% % %         lonii = 0;
% % %         for lon =-180:2:180;
% % %             lonii = lonii +1;
% % %             ii = ii+1;
% % %             radial(kt+1,latii,lonii) = a(ii,2);
% % %         end
% % %     end
% % % end
% % % a1 = radial(2,:,:);
% % % a2 = reshape(a1,91,181);
% % % figure(11); imagesc(a2); title('radial displacement'); colorbar
% % % % Calculate minimum
% % % figure(21); 
% % % mindisp = zeros(21,1);
% % % for ii = 3:23
% % %     mindisp(ii-2) = min(min(radial(ii,:,:)));
% % % end
% % % plot(time,mindisp,'LineWidth',2)
% % % xlabel('time [years]')
% % % ylabel('minimum displacement [m]')
% % % f2 = fit(time,mindisp,'smoothingspline');
% % % % Derivative
% % % timevec = [0:2:time(end)];
% % % y = feval(f2,timevec);
% % % yp = 1000*differentiate(f2,timevec);
% % % figure(30);
% % % hd(jj) = plot(timevec,yp,'LineWidth',2,'Displayname','3D');
% % % [i,minp] = min( abs(   abs(yp-yp(1))-abs( (1-exp(-num_reltime))*yp(1) ) ) );
% % % %%
% % % plot(timevec(minp),yp(minp),'*','MarkerEdgeColor','k','MarkerSize',10,'Displayname','3D')
% % % text(timevec(minp),yp(minp)+10,num2str(timevec(minp)))
% % % axis([0 3000 0 250])
% % % legend
% % % hold off
% % % legend('boxoff')
% % % reltime4 = timevec(minp)/num_reltime
% % % disp(['relaxation time 3D = ',num2str(reltime4)])
% % % 
% % % 
% % % 
